stages:
  - check
  - build


include:
  - template: Security/Secret-Detection.gitlab-ci.yml

secret_detection:
  extends: .secret-analyzer
  stage: check
  variables:
    SECRET_DETECTION_HISTORIC_SCAN: "false"
    SECRET_DETECTION_REPORT_FILE: "gl-secret-detection-report.json"
  artifacts:
    reports:
      secret_detection: $SECRET_DETECTION_REPORT_FILE
    expire_in: 7 days
  rules:
    - if: $CI_PIPELINE_SOURCE == "push"
    - if: $CI_PIPELINE_SOURCE == "schedule" && $CI_COMMIT_BRANCH == "develop"
    - if: $CI_PIPELINE_SOURCE == "trigger" && $CI_COMMIT_TAG == null
    - if: $CI_PIPELINE_SOURCE == "web" && $CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH == null
  allow_failure: false
  before_script:
    - apk add --no-cache jq
  script:
    - /analyzer run
    - |
      if [ -f "$SECRET_DETECTION_REPORT_FILE" ]; then
        if [ "$(jq ".vulnerabilities | length" $SECRET_DETECTION_REPORT_FILE)" -gt 0 ]; then
          echo "Vulnerabilities detected!"
          echo "Please check the $SECRET_DETECTION_REPORT_FILE security file."
          echo "Or run gitleak locally on your repository."
          exit 1
        fi
      else
        echo "Artifact $SECRET_DETECTION_REPORT_FILE does not exist."
        echo "No evaluation can be performed."
      fi      

Build clock image:
  image: registry.gitlab.com/naturalis/lib/docker-cli-extras:24.0.5-cli
  services:
    - docker:24.0.5-dind
  stage: build
  script:
    - echo -n ${CI_REGISTRY_PASSWORD} | docker login -u ${CI_REGISTRY_USER} --password-stdin ${CI_REGISTRY}
    - (cd docker && docker image build --no-cache --pull --tag "${CI_REGISTRY_IMAGE}:clock" .)
    - docker push "${CI_REGISTRY_IMAGE}:clock"

#HelloSecretContainer:
#  image: registry.gitlab.com/naturalis/lib/docker-cli-extras:24.0.5-cli
#  services:
#    - docker:24.0.5-dind
#  stage: container
#  script:
#    - echo -n ${CI_REGISTRY_PASSWORD} | docker login -u ${CI_REGISTRY_USER} --password-stdin ${CI_REGISTRY}
#    - (cd docker && docker image build -f secret.clock.Dockerfile --no-cache --pull --tag "${CI_REGISTRY_IMAGE}:secret" .)
#    - docker push "${CI_REGISTRY_IMAGE}:secret"

